(* $Id: client.ml,v 1.6 2002/09/02 18:54:44 berdine Exp $ *)

let connect host port =
  Unix.open_connection (Unix.ADDR_INET (Unix.inet_addr_of_string host,
										port))

let join_game ochan =
  begin
 	output_string ochan "Player\n"; 
(* 	output_string ochan "Login 9 9\n"; *)
	flush ochan
  end

let disconnect = Unix.shutdown_connection



let output ochan str =
  output_string ochan (str ^ "\n");
  flush ochan;
  print_endline ("< " ^ str)

let manual_command =
  let i = ref 0 in
  let a = [|"1 Pick 21";
			"1 Move E"; "1 Move E"; "1 Move E"; "1 Move E"; "1 Move E"; "1 Move E"; "1 Move E"; "1 Move E"; "1 Move E";
			"1 Move S"; "1 Move S"; "1 Move S"; "1 Move S"; "1 Move S"; "1 Move S"; "1 Move S"; "1 Move S"; "1 Move S"; "1 Move S"; "1 Move S"; "1 Move S"; "1 Move S";	"1 Move S";
			"1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W";	"1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W"; "1 Move W";
			"1 Drop 21";
			"5000 Drop"|] in
  fun c () ->
	begin
	  output c a.(!i);
	  i := !i + 1
	end



let main () =
  let host = Sys.argv.(1) in
  let port = int_of_string Sys.argv.(2) in
  let (ichan, ochan) = connect host port in
  begin
	join_game ochan;
	World.input_map ichan;
	World.input_player_config ichan;
	Global_decision.init ();
	try
	  while true do
		Configuration.input_update ichan;
		Configuration.input_packages ichan;
		Configuration.pr_config ();
		Global_decision.output_command ochan;
(* 		manual_command ochan () *)
	  done
	with e -> begin disconnect ichan; raise e end
  end

let _ = main ()
