let w = 10
let h = 10
let n = (w+2) * (h+2)
let empty = -1
let dist_sep = -2
let border = -3
let wall = -4
let a = Array.make n empty

let rec make_divisible_by d n =
  if n mod d = 0 then n else make_divisible_by d (n+1)

let l = ref 0
let l1 = ref 0
let dist = ref 0
let good_power_of_two = 1024 (* calculate modulo ops only every so many operations *)
let q_size = make_divisible_by good_power_of_two (2*w+2*h+1)
let q = Array.make q_size 0

let add_some_walls () =
  for i = 0 to n-1
  do
    if (Random.int 3) = 0 then a.(i) <- wall
  done

let print_current () =
  let k = ref !l in
  Format.print_newline ();
  Format.printf "l: ";
  while q.(!k) != dist_sep do
    Format.printf "q.(%d) = %d " !k q.(!k);
    incr k
  done;
  Format.print_newline ();
  incr k;
  Format.printf"l1: ";
  while !k <= !l1 do
    Format.printf "q.(%d) = %d " !k q.(!k);
    incr k
  done;
  Format.print_newline ()

let dostuff () =
 for i=0 to w+1 do a.(i) <- border done;
 for i=n-(w+2) to n-1 do a.(i) <- border done;
 for i=1 to h do a.(i*(w+2)) <- border done;
 for i=1 to h do a.(i*(w+2)+w+1) <- border done;

 let incrq x =
   x := if !x mod good_power_of_two = good_power_of_two -1 then (!x + 1) mod q_size else !x + 1 in
 q.(0) <- w+3 (* + (w/2) + (w+2)*(h/2) *);
 q.(1) <- dist_sep;
 l := 0;
 l1 := 1;
 while !l != !l1 do
   assert (!l != !l1 +1);
   let i = q.(!l) in
     (* print_current (); *)
     incrq l;
     if (i != dist_sep)
     then if a.(i) = empty
       then
         begin
           a.(i) <- !dist;
	   if a.(i-1) = empty then (incrq l1; q.(!l1) <- i-1);
	   if a.(i+1) = empty then (incrq l1; q.(!l1) <- i+1;
	      (* Format.printf "i+1:%d a.(i+1):%d" (i+1) a.(i+1);
               Format.print_newline () *));
	   if a.(i-(w+2)) = empty then (incrq l1; q.(!l1) <- i-(w+2));
	   if a.(i+(w+2)) = empty then (incrq l1; q.(!l1) <- i+(w+2))
         end
       else ()
     else
       begin
         incr dist;
         (* incr l; *)
	 incrq l1;
         q.(!l1) <- dist_sep
       end
 done

exception Origin_not_reachable

let mark_back dest =
  let r = ref dest in
  while a.(!r) != 0
  do
    let i = !r in
    let next = Array.of_list [i-1; i+1; i-(w+2); i+(w+2)] in
    let j = Random.int 4 in
    let (n1,n2,n3,n4) = (next.(j), next.((j+1) mod 4), next.((j+2) mod 4), next.((j+3) mod 4))
    in
     begin
      if a.(n1) + 1 = a.(i) then r := n1 else
      if a.(n2) + 1 = a.(i) then r := n2 else
      if a.(n3) + 1 = a.(i) then r := n3 else
      if a.(n4) + 1 = a.(i) then r := n4
      else raise Origin_not_reachable
    end;
    a.(i) <- 0
  done

let print_arr () =
 let pp n = match n with
            | 0 -> Format.printf "%3s" "*"
	    | n when n=empty -> Format.printf "%3s" "."
	    | n when n=border -> Format.printf "%3s" "+"
	    | n when n=wall -> Format.printf "%3s" "#"
	    | _ -> Format.printf "%3d" n in
 for j=0 to h+1 do
  for i=0 to w+1 do pp a.(i + (w+2)*j) done;
  Format.print_newline ()
 done

let index_of_coords (x,y) = x + 1 + (w+2)*(y+1)

let mk_zigzag () =
  for i = 1 to h-1
  do
    let (l,r) = match i mod 4 with
                | 1 -> (index_of_coords (0,i), index_of_coords (w-2,i))
                | 3 -> (index_of_coords (1,i), index_of_coords (w-1,i))
		| _ -> (0,0)
    in for j = l to r do a.(j) <- wall done 
  done

let _ = (* add_some_walls (); *)
        (* mk_zigzag (); *)
        dostuff ();
        print_arr ();
	mark_back (n-(w+4));
	Format.printf "Back path:";
	Format.print_newline ();
	print_arr () 
