(* $Id: local_decision.mli,v 1.4 2002/09/02 17:17:08 pablo Exp $ *)

open Types
open Configuration

val gcd : int -> int -> int
val lcm : int -> int -> int
val lcml : int list -> int
val length : int
val weights : int array array
val dir : (int * int * int * int * int) array array

val init : unit -> unit
val add_tuples :
  int * int * int * int * int ->
  int * int * int * int * int -> int -> int * int * int * int * int
val water : int
val wall : int
val pack : int
val enemy : int

type direction = char

type priority = int (* non-zero *)

type direction_weights = int * int * int * int * int

type command =
  | CMove of priority * direction
  | CPick of priority * Package.IdSet.t
  | CDrop of priority * Package.IdSet.t

val choose_command : direction_weights -> command
