(* $Id: package.ml,v 1.2 2002/09/01 07:28:16 berdine Exp $ *)

open Types

type id = int
type pkg_desc = {w: int; d: coords}

module IdSet = Set.Make (struct type t = id let compare = compare end)

let known_pkgs = Hashtbl.create 2048

let desc id = Hashtbl.find known_pkgs id

let new_known id weight dest =
  if not (Hashtbl.mem known_pkgs id)
  then Hashtbl.add known_pkgs id {w= weight; d= dest}

let with_dest ids dst =
  let at_dst id = (desc id).d = dst in IdSet.filter at_dst ids
