(* $Id: world.ml,v 1.2 2002/09/02 15:31:39 berdine Exp $ *)

open Types

type map = {width: int; height: int; tiles: string array}

let map_rep = ref {width= 0; height= 0; tiles= [||]}

let input_map_dimens ichan =
  let line = input_line ichan in
  match Str.split (Str.regexp " ") line with
  | [x; y] -> (int_of_string x, int_of_string y)
  | _ -> failwith "Got bad map dimensions line."

let input_map ichan =
  let (width, height) = input_map_dimens ichan in
  let tiles = Array.make height "" in
  begin
	for j = 0 to height-1 do
	  tiles.(j) <- input_line ichan
	done;
	map_rep := {width= width; height= height; tiles= tiles};
  end


type player = {id: robot_id; starting_money: int; capacity: int}

let player_rep = ref {id= no_id; capacity= 0; starting_money= 0}

let input_player_config ichan =
  let line = input_line ichan in
  match Str.split (Str.regexp " ") line with
  | [i; c; m] ->
	  player_rep := {id= int_of_string i;
					 capacity= int_of_string c;
					 starting_money= int_of_string m}
  | _ -> failwith "Got bad player configuration line."
